module.exports = {
  dependencies: [ 'chalk' ], // Needed NPM Modules, these modules will be installed using `npm i <dependency>...`
  config: [ 'compilerOptions.message' ], // Custom properties introduced, eg. "compilerOptions.someProperty" in tsconfig
  arguments: { // Custom arguments when using tsc
    messageVarName: [ 'm', 'message' ] // Used like "tsc --message 'Cool Message'" or "tsc -m 'Cool Alias'"
  },
  onInitCompilation: function() {
    // This function is executed before tsc has started compilation
    console.log('Before compilation');
    console.log(this);

    // this.config.compilerOptions.message
    // this.args.messageVarName
  },
  onPostCompilation: function() {
    // This function is executed after tsc has completed compilation
    console.log('After compilation');
  }
}